﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace UrlCleaner
{
    /// <summary>
    /// Present 'find' options and fire event when button's pressed.
    /// 
    /// *** Note - only partially implemented ***
    /// 
    /// Author: Dennis Lang - 2009
    /// http://home.comcast.net/~lang.dennis/
    /// </summary>    
    public partial class FindDialog : Form
    {
        public FindDialog()
        {
            InitializeComponent();
        }

        public class FindEventArgs : EventArgs
        {
            public enum Action { First, Next, All };
            public Action action;

            public string toFind;

            public bool isLeftPanel;
            public bool isRightPanel;

            public bool isInnerText;
            public bool isAttributeName;
            public bool isAttributeValue;

            public bool isMatchCase;
            public bool isRegularExpression;

#if false
            public TreeNode leftNode;
            public int leftIdx;

            public TreeNode rightNode;
            public int rightIdx;
#endif
        }

        FindEventArgs findEventArgs = new FindEventArgs();
        public delegate void FindEventHandler(object sender, FindEventArgs e);
        public event FindEventHandler findEventHandler;

        private void findFirstBtn_Click(object sender, EventArgs e)
        {
            FireFind(FindEventArgs.Action.First);
        }

        private void findNextBtn_Click(object sender, EventArgs e)
        {
            FireFind(FindEventArgs.Action.Next);
        }

        private void findAllBtn_Click(object sender, EventArgs e)
        {
            FireFind(FindEventArgs.Action.All);
        }

        public FindEventArgs GetArgs
        {
            get
            {
                findEventArgs.toFind = whatCombo.Text;

                findEventArgs.isMatchCase = matchCaseCk.Checked;
                findEventArgs.isRegularExpression = regularExpCk.Checked;

                return findEventArgs;
            }
        }

        private void FireFind(FindEventArgs.Action action)
        {
            GetArgs.action = action;
           
            if (findEventHandler != null)
                findEventHandler(this, findEventArgs);
        }

        protected override void OnClosing(CancelEventArgs e)
        {
            e.Cancel = true;
            base.OnClosing(e);
            this.Visible = false;
        }
    }
}
