using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace UrlCleaner
{
    /// <summary>
    /// Used to prompt for input from a tabular list field.
    /// Place box directly over tabular list field.
    /// 
    /// Author: Dennis Lang - 2011
    /// http://home.comcast.net/~lang.dennis/
    /// </summary>
    public partial class FieldBox : Form
    {
        public FieldBox()
        {
            InitializeComponent();
        }

        public string FieldText
        {
            get { return this.textBox.Text; }
            set { this.textBox.Text = value; }
        }

        private void textBox_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Return)
            {
                this.DialogResult = DialogResult.OK;
                this.Close();
            }
            else if (e.KeyCode == Keys.Escape)
            {
                this.DialogResult = DialogResult.Cancel;
                this.Close();
            }
        }
    }
}