﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;
using System.IO;

namespace UrlCleaner
{
    /// <summary>
    /// Delete file or directory by placing it in recycle bin so it can undone.
    /// 
    /// A deleted code example can be found:
    /// http://social.msdn.microsoft.com/Forums/hu-HU/netfxbcl/thread/ce1e8a4a-dd6b-4add-84d1-95faa3d13404
    /// </summary>
    class RecycleFile
    {
        [StructLayout(LayoutKind.Sequential, CharSet=CharSet.Auto, Pack=1)] 
            public struct SHFILEOPSTRUCT 
        { 
                public IntPtr hwnd; 
                [MarshalAs(UnmanagedType.U4)] public int wFunc; 
                public string pFrom; 
                public string pTo; 
                public short fFlags; 
                [MarshalAs(UnmanagedType.Bool)] public bool fAnyOperationsAborted; 
                public IntPtr hNameMappings; 
                public string lpszProgressTitle; 

        } 

        [DllImport("shell32.dll", CharSet=CharSet.Auto)] 
        static extern int SHFileOperation(ref SHFILEOPSTRUCT FileOp); 
        const int FO_DELETE = 3; 
        const int FOF_ALLOWUNDO = 0x40; 
        const int FOF_NOCONFIRMATION = 0x10;    //Don't prompt the user.; 

        /// <summary>
        ///     Delete file or directoy by moving it to the recycle bin.
        ///     return true if successful.
        /// </summary>
        static public void DeleteFile(string path)
        {
            SHFILEOPSTRUCT shf = new SHFILEOPSTRUCT(); 
            shf.wFunc = FO_DELETE; 
            shf.fFlags = FOF_ALLOWUNDO | FOF_NOCONFIRMATION;
            shf.pFrom = path + '\0' + '\0';

            int zeroOk = SHFileOperation(ref shf); 

            if (zeroOk != 0)
                throw new FileNotFoundException("Delete failed", path);

        }
    }
}
